Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000160Core InformRelationspublic2010-07-02 14:222010-10-28 00:31
Reporterjmcgrew 
Assigned Tograham 
PrioritynormalSeveritymildReproducibilityalways
StatusclosedResolutionfixed 
Platformx86OSWindowsOS Version7
Product Version6E59 
Target VersionFixed in Version6F95 
Summary0000160: "the _ which _ relates to by _" and related phrases don't work with static relations
DescriptionRELS_LOOKUP_ANY, RELS_LOOKUP_ALL_X, RELS_LOOKUP_ALL_Y, and RELS_LIST are not implemented by the generated relation handlers, which affects these phrases:

list of (name of kind of value K) that/which/whom (R - relation of Ks to values of kind L) relates
list of (name of kind of value L) to which/whom (R - relation of values of kind K to Ls) relates
list of (name of kind of value L) that/which/whom (R - relation of values of kind K to Ls) relates to
list of (name of kind of value K) that/which/who relate to (Y - L) by (R - relation of Ks to values of kind L)
list of (name of kind of value L) to which/whom (X - K) relates by (R - relation of values of kind K to Ls)
list of (name of kind of value L) that/which/whom (X - K) relates to by (R - relation of values of kind K to Ls)
whether (name of kind of value K) relates to (Y - L) by (R - relation of Ks to values of kind L)
whether (X - K) relates to (name of kind of value L) by (R - relation of values of kind K to Ls)
(name of kind of value K) that/which/who relates to (Y - L) by (R - relation of Ks to values of kind L)
(name of kind of value L) to which/whom (X - K) relates by (R - relation of values of kind K to Ls)
(name of kind of value L) that/which/whom (X - K) relates to by (R - relation of values of kind K to Ls)

Using any of these phrases on a non-dynamic relation results in runtime errors or incorrect results.
Minimal Source Text To Reproduce
Chapel is a room.

Marriage relates one person to another. The verb to be married to implies the marriage relation.

John is married to Marsha.

When play begins:
	let John's spouse be the person who relates to John by the marriage relation;
	say "John's spouse: [John's spouse].";
	let John's spice be the list of people who relate to John by the marriage relation;
	say "John's spice: [John's spice]."
Additional InformationThe code above prints:

<quote>
John's spouse: nothing.
*** Deep copy failed: source empty ***
John's spice: .
</quote>

Relation-type variables may refer to static as well as dynamic relations, so given a relation variable R, there's no way to know whether these phrases can be safely used on R (short of dropping to I6 and checking the handler address).
TagsNo tags attached.
Effect(serious/mild) Game compiles but misbehaves
Attached Files

- Relationships
related to 0000568closedgraham "Let V be the <kind> that relates to <an object> by <a relation of objects to objects>" triggers a programming error 

-  Notes
(0000695)
graham (administrator)
2010-10-13 16:38

I have now written the code to generate the code to provide these values and lists, which should put everything right. No excuse, really - an oversight with the last major build, when there was such a lot to do.

- Issue History
Date Modified Username Field Change
2010-07-02 14:22 jmcgrew New Issue
2010-07-02 14:23 jmcgrew Status new => acknowledged
2010-07-02 14:23 jmcgrew Description Updated View Revisions
2010-07-02 14:24 jmcgrew Summary "the _ which _ relates to via _" and related phrases don't work with static relations => "the _ which _ relates to by _" and related phrases don't work with static relations
2010-07-02 16:24 EmacsUser Status acknowledged => confirmed
2010-10-13 16:38 graham Note Added: 0000695
2010-10-13 16:38 graham Status confirmed => resolved
2010-10-13 16:38 graham Resolution open => fixed
2010-10-13 16:38 graham Assigned To => graham
2010-10-25 21:14 jmcgrew Fixed in Version => 6F95
2010-10-28 00:31 jmcgrew Status resolved => closed
2011-02-18 10:58 jmcgrew Relationship added related to 0000568


Copyright © 2000 - 2010 MantisBT Group
Powered by Mantis Bugtracker